%{

#undef NEW_LEX_STYLE

/* undef NEW_LEX_STYLE if you want the old, slow behaviour. The new one
 * is in the testing phase. Fixes or hints are appreciated if you can't
 * compile or lex it.
 */


#ifndef lint
static char *RCSid = "$Id: lexsrc.l,v 1.13 1993/05/10 05:51:00 anders Exp anders $";
#endif

/*
 *  The Regina Rexx Interpreter
 *  Copyright (C) 1992-1994  Anders Christensen <anders@pvv.unit.no>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "rexx.h"
#include "symbols.h"
#include <ctype.h>
#include <string.h>
#include <assert.h>


#ifdef YYLMAX
# undef YYLMAX
#endif
#define YYLMAX BUFFERSIZE

#ifdef FLEX_SCANNER
#undef YY_CHAR
#undef yywrap
#define YY_CHAR YY_CHAR_TYPE
#undef YY_INPUT
#ifndef NEW_LEX_STYLE
#define YY_INPUT(buf,result,max_size)\
     { int c=mygetchar(); result=((c==EOF)?0:(buf[0]=c,1)) ; }
     /* returning 0 in the line above allows trapping mismatched comments or
      * quotes
      */
#else
#define YY_INPUT(buf,result,max_size) result=fill_buffer(buf,max_size)
#endif
#else
#undef input
/* FGC: Will this ever run? Many things are done by mygetchar! */
#define input() (yylastch<yytext+YYLMAX-1?(((yytchar=yysptr>yysbuf?U(*--yysptr):mygetchar())=='\n'?(yylineno++,yytchar):yytchar)==EOF?0:yytchar):( exiterror( ERR_TOO_LONG_LINE, 0 ) ,yytchar))
#endif

/* NOTE: Every comment is replaced by a '`' character in the lower input
 * routines. These should check for such (illegal) characters.
 */
#define isblank(c) (((c)==' ')||((c)=='\t')||((c)=='`'))

YY_CHAR_TYPE *yylastch = NULL ;

/* globals */
nodeptr currentnode=NULL ;
lineboxptr first_source_line=NULL, last_source_line=NULL ;
int retlength=0 ;
char retvalue[BUFFERSIZE] ;

/* externals */
extern int nextline ; /* Useless, should be removed */
extern int thischar, nextstart, tstart, tline ;
extern sysinfo systeminfo ;

/* locals */
static int do_level = 0 ;
static int in_numform=0, next_numform=0 ;
static int obs_with=0, in_do=0, in_then=0, dontlast=0 ;
static int sum=0, nnextstart=0, nnextline ;
static int i, j, k, code=0, next=0, in_parse=0, in_trace=0, itflag=0 ;
static int in_signal=0, in_call=0, in_address=0 ;
static int seek_with=0 ;
static int prev=0, last=0 ;
static char char1, ch, ech ;
static int kill_this_space=0, kill_next_space=1 ;

static YY_CHAR_TYPE *rmspc( YY_CHAR_TYPE *instr ) ;
#ifdef NEW_LEX_STYLE
static int fill_buffer( char *buf, int max_size ) ;
#else
static int mygetc( FILE *str ) ;
static int mygetchar(void) ;
static void myungetc( int ch, FILE *dummy ) ;
static int mmygetchar(void) ;
#endif

%}


%start comm signal sgtype procd parse then with
%start numeric do1 other value1 ifcont signame nmform

%e 2500
%p 17000
%k 1500
%a 7000
%n 1000
%o 8000

%{
/* int yy_startcond=comm ; FGC: Needless? */
%}

not [\\^~]

csym [0-9.][a-zA-Z0-9.@#$!?_]*
ssym [a-zA-Z@#$!?_][a-zA-Z0-9.@#$!?_]*
strs ('([^']|'')*'|\"([^"]|\"\")*\")
labl ({sym}|{strs})+
sym [a-zA-Z0-9.@#$!?_]+
hsym [\t a-fA-F0-9]
bsym [\t 01]
hex {bl}*{hsym}*({bl}+({hsym}{hsym})+)*{bl}*
bin {bl}*{bsym}*({bl}+({bsym}{bsym}{bsym}{bsym})+)*{bl}*

vtail [a-zA-Z@#$!?_][a-zA-Z0-9@#$!?_]*
ctail [0-9][a-zA-Z0-9@#$!?_]*


a [aA]
b [bB]
c [cC]
d [dD]
e [eE]
f [fF]
g [gG]
h [hH]
i [iI]
j [jJ]
k [kK]
l [lL]
m [mM]
n [nN]
o [oO]
p [pP]
q [qQ]
r [rR]
s [sS]
t [tT]
u [uU]
v [vV]
w [wW]
x [xX]
y [yY]
z [zZ]


bl (\ |\`|\t)*
bbl (\ |\t)+

%%

   { if (next==1) {
        next = 0 ;
        last = (dontlast==0) ;
        dontlast = 0 ;
        return code ; }

     if (next_numform)
     {
        in_numform = 1 ;
        next_numform = 0 ;
     }
     else
        in_numform = 0 ;

     if (in_address)
        in_address-- ;

     kill_this_space = kill_next_space ;
     kill_next_space = 0 ;


     if (itflag)
        in_trace = seek_with = 0 ;
     itflag = (in_trace) ;

     tstart = nextstart ;   /* used to be thischar */
     tline = nextline ;
     prev = last ;
     last = 0 ; }

\` ;

<ifcont>{bl}[;\r?\n]{bl} {
   nextstart = thischar ;
   return STATSEP ; }

{bl}(;|\r?\n){bl} {
   BEGIN comm ;
   if (obs_with==1)
       exiterror( ERR_INVALID_TEMPLATE, 1, yytext )  ;
   obs_with = in_do = 0 ;
   in_signal = in_address = in_call = 0 ;
   in_parse = 0 ;
   nextstart = thischar ;
   return STATSEP ; }

<comm>{a}{d}{d}{r}{e}{s}{s}{bl} {
   BEGIN value1 ;
   in_signal = 1 ;
   in_address = 2 ;
   return ADDRESS ; }

<comm>{a}{r}{g}{bl} {
   BEGIN other ;
   in_parse = 1 ;
   return ARG ; }

<comm>{c}{a}{l}{l}{bl} {
   BEGIN signal ;
   in_call = 1 ;
   return CALL ; }

<comm>{d}{o}{bl} {
   BEGIN do1 ;
   assert( do_level >=0 ) ;
   do_level++ ;
   in_do = 1 ;
   return DO ; }

<comm>{d}{r}{o}{p}{bl} {
   BEGIN other ;
   in_parse = 1 ;
   return DROP ; }

<comm>{e}{l}{s}{e}{bl} {
   BEGIN comm ;
   return ELSE ; }

<comm>{e}{x}{i}{t}{bl} {
   BEGIN other ;
   return EXIT ; }

<comm>{i}{f}{bl} {
   BEGIN ifcont ;
   in_then = 1 ;
   return IF ; }

<comm>{i}{n}{t}{e}{r}{p}{r}{e}{t}{bl} {
   BEGIN other ;
   return INTERPRET ; }

<comm>{i}{t}{e}{r}{a}{t}{e}{bl} {
   BEGIN other ;
   return ITERATE ; }

<comm>{l}{e}{a}{v}{e}{bl} {
   BEGIN other ;
   return LEAVE ; }

<comm>{o}{p}{t}{i}{o}{n}{s}{bl} {
   BEGIN other ;
   return OPTIONS ; }

<comm>{n}{o}{p}{bl} {
   BEGIN other ;
   return NOP ; }

<comm>{n}{u}{m}{e}{r}{i}{c}{bl} {
   BEGIN numeric ;
   return NUMERIC ; }

<comm>{p}{a}{r}{s}{e}{bl} {
   BEGIN parse ;
   in_parse = 1 ;
   return PARSE ; }

<comm>{p}{r}{o}{c}{e}{d}{u}{r}{e}{bl} {
   BEGIN procd ;
   return PROCEDURE ; }

<comm>{p}{u}{l}{l}{bl} {
   BEGIN other ;
   in_parse = 1 ;
   return PULL ; }

<comm>{p}{u}{s}{h}{bl} {
   BEGIN other ;
   return PUSH ; }

<comm>{q}{u}{e}{u}{e}{bl} {
   BEGIN other ;
   return QUEUE ; }

<comm>{r}{e}{t}{u}{r}{n}{bl} {
   BEGIN other ;
   return RETURN ; }

<comm>{s}{a}{y}{bl} {
   BEGIN other ;
   return SAY ; }

<comm>{s}{e}{l}{e}{c}{t}{bl} {
   BEGIN other ;
   assert( do_level >= 0 ) ;
   do_level++ ;
   return SELECT ; }

<comm>{s}{i}{g}{n}{a}{l}{bl} {
   BEGIN signal ;
   in_signal = 1 ;
   return SIGNAL ; }

<comm>{t}{r}{a}{c}{e}{bl} {
   BEGIN value1 ;
   in_trace = 1 ;
   return TRACE ; }

<comm>{w}{h}{e}{n}{bl} {
   BEGIN ifcont ;
   in_then = 1 ;
   return WHEN ; }

<comm>{o}{t}{h}{e}{r}{w}{i}{s}{e}{bl} {
   BEGIN comm ;
   return OTHERWISE ; }

<comm>{e}{n}{d}{bl} {
   BEGIN other ;
   assert( do_level >= 0 ) ;
   if (do_level==0)
       exiterror( ERR_UNMATCHED_END, 1 )  ;
   do_level-- ;
   return END ; }

{bl} {
   if (in_parse)
      return yylex() ;
   else
      REJECT ; }

\. {
   if (in_parse)
      return PLACEHOLDER ;
   else
   {
      REJECT ;
      retvalue[0] = '.' ;
      retvalue[1] = '\0' ;
      return CONSYMBOL ;
   }
 }

<comm>{csym}{bl}={bl} {
    char1 = yytext[0] ;

    if (char1 == '.')
       exiterror( ERR_INVALID_START, 3, yytext )  ;
    else
       exiterror( ERR_INVALID_START, 2, yytext )  ; }

<comm>{ssym}{bl}={bl} {
   BEGIN other ;

   j = 0 ;
   for (i=0;yytext[i];i++)
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[j++] = (char) (yytext[i] & 0xDF) ; /* ASCII only */
      else if (yytext[i]!='='  && yytext[i]!='\n' && !isblank(yytext[i]))
         retvalue[j++] = yytext[i] ;
   retvalue[j] = '\0' ;

   return ASSIGNMENTVARIABLE ; }

<nmform,signal,value1>{bl}{v}{a}{l}{u}{e}{bl} {
   if (in_call) REJECT ;
   BEGIN other ;
   if ((!in_trace)&&(!in_address)&&(!in_signal)&&(!in_call)&&(!in_numform))
      obs_with = 1 ;
   in_trace = in_signal = in_call = in_address = 0 ;
   return VALUE ; }

<signal>{o}{n}{bl} {
   BEGIN sgtype ;
   return ON ; }

<signal>{o}{f}{f}{bl} {
   BEGIN sgtype ;
   return OFF ; }

<signame>{n}{a}{m}{e}{bl} {
   BEGIN other ;
   return NAME ; }

<sgtype>{e}{r}{r}{o}{r}{bl} {
   BEGIN signame ;
   return ERROR ; }

<sgtype>{h}{a}{l}{t}{bl} {
   BEGIN signame ;
   return HALT ; }

<sgtype>{n}{o}{v}{a}{l}{u}{e}{bl} {
   BEGIN signame ;
   return NOVALUE ; }

<sgtype>{n}{o}{t}{r}{e}{a}{d}{y}{bl} {
   BEGIN signame ;
   return NOTREADY ; }

<sgtype>{f}{a}{i}{l}{u}{r}{e}{bl} {
   BEGIN signame ;
   return FAILURE ; }

<sgtype>{s}{y}{n}{t}{a}{x}{bl} {
   BEGIN signame ;
   return SYNTAX ; }

<value1>{bl}[a-zA-Z?]+{bl} {
   if (!in_trace) REJECT ;
   strcpy(retvalue,rmspc( yytext )) ;
   return WHATEVER ; }

<procd>{e}{x}{p}{o}{s}{e}{bl} {
   BEGIN other ;
   in_parse = 1 ;
   return EXPOSE ; }

<parse>{u}{p}{p}{e}{r}{bl} {
   return UPPER ; }

<parse>{a}{r}{g}{bl} {
   BEGIN other ;
   return ARG ; }

<parse>{n}{u}{m}{e}{r}{i}{c}{bl} {
   BEGIN other ;
   return NUMERIC ; }

<parse>{p}{u}{l}{l}{bl} {
   BEGIN other ;
   return PULL ; }

<parse>{s}{o}{u}{r}{c}{e}{bl} {
   BEGIN other ;
   return SOURCE ; }

<parse>{e}{x}{t}{e}{r}{n}{a}{l}{bl} {
   BEGIN other ;
   return EXTERNAL ; }

<parse>{l}{i}{n}{e}{i}{n}{bl} {
   BEGIN other ;
   return LINEIN ; }

<parse>{v}{e}{r}{s}{i}{o}{n}{bl} {
   BEGIN other ;
    return VERSION ; }

<parse>{v}{a}{r}{bl} {
   BEGIN other ;
   return VAR ; }

<parse>{v}{a}{l}{u}{e}{bl} {
   seek_with = 1 ;
   in_trace = 0 ;
   in_parse = 0 ;
   BEGIN with ;
   return VALUE ; }

<comm>{bl}{t}{h}{e}{n}{bl} {
   in_then = 0 ;
   return THEN ; }

<other,ifcont>{bl}{t}{h}{e}{n}{bl} {
   if (in_then!=1) REJECT ;
   BEGIN comm ;
   in_then = 0 ;
   return THEN ; }

{bl}{w}{i}{t}{h}{bl} {
   BEGIN other ;
   if ((in_do)||(!seek_with))
      REJECT ;
   seek_with = 0 ;
   in_parse = 1 ;
   return WITH ; }


<numeric>{d}{i}{g}{i}{t}{s}{bl} {
   BEGIN other ;
   return DIGITS ; }

<numeric>{f}{o}{r}{m}{bl} {
   BEGIN nmform ;
   next_numform = 1 ;
   return FORM ; }

<nmform>{s}{c}{i}{e}{n}{t}{i}{f}{i}{c}{bl} {
   return SCIENTIFIC ; }

<nmform>{e}{n}{g}{i}{n}{e}{e}{r}{i}{n}{g}{bl} {
   return ENGINEERING ; }

<numeric>{f}{u}{z}{z}{bl} {
   BEGIN other ;
   return FUZZ ; }

<do1>{f}{o}{r}{e}{v}{e}{r}{bl} {
   BEGIN other ;
   assert(in_do) ;
   in_do = 2 ;
   return FOREVER ; }

{bl}{t}{o}{bl} {
   if (in_do==2) {
      BEGIN other ;
      return TO ; }
   else if (in_do==1)
       exiterror( ERR_INVALID_DO_SYNTAX, 0 )  ;
   REJECT ; }

{bl}{b}{y}{bl} {
   if (in_do==2) {
      BEGIN other ;
      return BY ; }
   else if (in_do==1)
       exiterror( ERR_INVALID_DO_SYNTAX, 0 )  ;
   REJECT ; }

{bl}{f}{o}{r}{bl} {
   if (in_do==2) {
      BEGIN other ;
      return FOR ; }
   else if (in_do==1)
       exiterror( ERR_INVALID_DO_SYNTAX, 0 )  ;
   REJECT ; }

{bl}{w}{h}{i}{l}{e}{bl} {
   if (in_do) {
      if (in_do==3)
          exiterror( ERR_INVALID_DO_SYNTAX, 0 )  ;

      in_do=3 ;
      BEGIN other ;
      return WHILE ; }
   REJECT ; }

{bl}{u}{n}{t}{i}{l}{bl} {
   if (in_do) {
      if (in_do==3)
          exiterror( ERR_INVALID_DO_SYNTAX, 0 )  ;

      in_do=3 ;
      BEGIN other ;
      return UNTIL ; }
   REJECT ; }


<do1>{ssym}{bl}/= {
   BEGIN other ;
   in_do = 2 ;
   strcpy(retvalue,rmspc( yytext )) ;
   return DOVARIABLE ; }

<comm>{sym}{bl}:{bl} {  /* set labl to sym for other kind or vice versa*/
   BEGIN comm ;

   for (i=j=0;(ch=yytext[i])!=0;i++) {
      if ('a' <= ch && ch <= 'z')
         retvalue[j++] = (char) (ch & 0xDF) ; /* ASCII only */
      /* FIXME: the following is WRONG, must first cut off {bl}:{bl} and
       * then fixup strings, FGC */
      else if ((ch!=',')&&(ch!='\n')&&(ch!=':')&&!isblank(ch))
         retvalue[j++] = ch ; }
   retvalue[j] = '\0' ;
  /* nnextline = nextline ;
   nnextstart = thischar ;
   nextstart = tstart ;
   nextline = tline ; */
   return LABEL ; }


('([^']|'')+'|\"([^"]|\"\")+\")`*\( {
   BEGIN other ;
   char1 = yytext[0] ;

   strcpy(retvalue,&yytext[1]) ;
   for (i=3; i<=yyleng && retvalue[yyleng-i]=='`'; i++) ;
   retvalue[yyleng-i] = '\0' ;

   kill_next_space = 1 ;
   if (prev==1) {
      next = dontlast = 1 ;
      code = EXFUNCNAME ;
      return CONCATENATE ; }

   last = 0 ;
   return EXFUNCNAME ; }



('{hex}'|\"{hex}\")[xX]/[^a-zA-Z0-9.@#$!?_(] {
   BEGIN other ;
   ech = yytext[0] ;

   /* first group can be large and odd-numbered; find # of zeros to pad */
   for (i=1; (yytext[i]!=ech) && isxdigit(yytext[i]); i++) ;

   /* j is the number of digits processed */
   j = (i-1)%2 ;
   sum = k = 0 ;

   for (i=1;(ech!=(ch=yytext[i]));i++)
   {
      if (isspace(ch))
      {
         if ((i==1)||(j))   /* leading space or space within a byte */
             exiterror( ERR_INVALID_HEX_CONST, 1, i )  ;
      }
      else if (isxdigit(ch))
      {
         sum = sum *16 + (HEXVAL(ch)) ;
         if ((++j)==2)
         {
            retvalue[k++] = (char) sum ;
            sum = j = 0 ;
         }
      }
   }

   if ((i>1) && isspace(yytext[i-1]))
       exiterror( ERR_INVALID_HEX_CONST, 1, i )  ;

   retvalue[k] = '\0' ;
   retlength = k ;

   if ((prev==1)&&(!in_parse))
   {
      next = 1 ;
      code = STRING ;
      return CONCATENATE ;
   }

   last = 1 ;
   return HEXSTRING ;
}



('{bin}'|\"{bin}\")[bB]/[^a-zA-Z0-9.@#$!?_(] {
   BEGIN other ;
   ech = yytext[0] ;

   /* first group can be large and odd-numbered; find # of zeros to pad */
   for (i=1; (yytext[i]!=ech) && isdigit(yytext[i]); i++) ;

   /* j is the number of digits processed */
   j = (4 - (i-1))%4 ;
   sum = k = 0 ;

   for (i=1;(ech!=(ch=yytext[i]));i++)
   {
      if (isspace(ch))
      {
         if ((i==1)||(j))   /* leading space or space within a byte */
               exiterror( ERR_INVALID_HEX_CONST, 2, i )  ;
      }
      else if ((ch=='0')||(ch=='1'))
      {
         sum = sum *2 + (ch-'0') ;
         if ((++j)==4)
         {
            retvalue[k++] = (char) sum ;
            sum = j = 0 ;
         }
      }
   }

   if ((i>1) && isspace(yytext[i-1]))
       exiterror( ERR_INVALID_HEX_CONST, 2, i )  ;

   j = (k%2) ;
   /* then pack the nibbles */
   for (i=j=(k%2); i<=k; i++)
   {
      if (i%2)
         retvalue[i/2] = (char)((retvalue[i/2]&0xf0) + retvalue[i-j]) ;
      else
         retvalue[i/2] = (char)((retvalue[i-j]&0x0f)<<4) ;
   }

   retvalue[retlength=i/2] = '\0' ;

   if ((prev==1)&&(!in_parse))
   {
      next = 1 ;
      code = STRING ;
      return CONCATENATE ;
   }

   last = 1 ;
   return BINSTRING ;
}


('([^']|'')*'|\"([^"]|"")*\")[xXbB]/[^a-zA-Z0-9.@#$!?_(] {
    exiterror( ERR_INVALID_HEX_CONST, 3, yytext )  ;
   }


('([^']|'')*'|\"([^"]|\"\")*\") {
   BEGIN other ;
   char1 = yytext[0] ;
   for (i=1; yytext[i+1]; i++)
   {
      if (yytext[i]=='\n')
          exiterror( ERR_UNMATCHED_QUOTE, 0 )  ;

      if (yytext[i]==char1 && yytext[i+1]==char1)
         for (j=i+1; yytext[j]; j++)
            yytext[j] = yytext[j+1] ;
   }

   yytext[strlen(yytext)-1] = '\0' ;
   strcpy(retvalue,&yytext[1]) ;

   if (in_numform)
       exiterror( ERR_INV_SUBKEYWORD, 11, "ENGINEERING SCIENTIFIC", retvalue )  ;

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = STRING ;
      return CONCATENATE ; }

   last = 1 ;
   return STRING ; }


[0-9]+ {
   if (!in_parse)
      REJECT ;
   strcpy(retvalue,yytext) ;
   return OFFSET ; }

((([0-9]+\.|\.?[0-9])[0-9]*{e}(\-|\+)[0-9]+))|([.0-9][a-zA-Z0-9.$!?@#_]*) {
   BEGIN other ;
   for (i=0;yytext[i];i++)
      if ('a' <= yytext[i] && yytext[i] <= 'z')
         retvalue[i] = (char) (yytext[i] & 0xDF) ; /* ASCII only */
      else
         retvalue[i] = yytext[i] ;
   retvalue[i] = '\0' ;

   if (in_numform)
       exiterror( ERR_INV_SUBKEYWORD, 11, "ENGINEERING SCIENTIFIC", retvalue )  ;

#if 1
   for (;(i=input())=='`';) ;
   if (i=='(')
   {
      BEGIN other ;
      kill_next_space = 1 ;
      if (prev==1)
      {
         next = dontlast = 1 ;
         code = INFUNCNAME ;
         return CONCATENATE ;
      }
      last = 0 ;
      return INFUNCNAME ;
   }
   else
   {
      unput(i) ;
   }
#endif

   if (in_call)
   {
      in_call = 0 ;
      BEGIN other ;
      kill_next_space = 1 ;
      last = 1 ;
      return CONSYMBOL ;
   }

   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = CONSYMBOL ;
      return CONCATENATE ; }

   last = 1 ;
   return CONSYMBOL ; }


{ssym} {
   /*
    * this might be a symbol in front of a function, but only if next
    * char in input stream is "(".
    */

   if (in_trace) REJECT ;

   for (i=0; i<=yyleng && yytext[yyleng-i]!='`'; i++)
      retvalue[i] = (char) toupper(yytext[i]) ;

   if (in_numform)
       exiterror( ERR_INV_SUBKEYWORD, 11, "ENGINEERING SCIENTIFIC", retvalue )  ;

   if (in_address)
   {
      kill_next_space = 1 ;
      in_address=0 ;
      return ENVIRONMENT ;
   }

   for (;(i=input())=='`';) ;
   if (i=='(')
   {
      BEGIN other ;
      kill_next_space = 1 ;
      if (prev==1)
      {
         next = dontlast = 1 ;
         code = INFUNCNAME ;
         return CONCATENATE ;
      }
      last = 0 ;
      return INFUNCNAME ;
   }
   else
   {
      unput(i) ;
   }

   if (in_call)
   {
      kill_next_space = 1 ;
      BEGIN other ;
      in_call = 0 ;
      last = 1 ;
      return SIMSYMBOL ;
   }

   BEGIN other ;
   if ((prev==1)&&(!in_parse)) {
      next = 1 ;
      code = SIMSYMBOL ;
      return CONCATENATE ; }

   last = 1 ;
   return SIMSYMBOL ; }


{bl}\) {
   last = 1 ;
   return ')' ; }

\({bl} {
   BEGIN other ;
   if (prev==1)
   {
      next = dontlast = 1 ;
      code = '(' ;
      return CONCATENATE ;
   }
   return '(' ; }

{bl}\,{bl} {
   return ',' ; }

{bl}\-{bl} {
   BEGIN other ;
   return '-' ; }

{bl}\+{bl} {
   BEGIN other ;
   return '+' ; }

{bl}\/{bl} {
   return '/' ; }

{bl}%{bl} {
   return '%' ; }

{bl}\*{bl} {
   return '*' ; }

{bl}\|{bl} {
   return '|' ; }

{bl}&{bl} {
   return '&' ; }

{bl}={bl} {
   return '=' ; }

{not}{bl} {
   /* why don't I have a {bl} in the beginning of this re? bug? */
   BEGIN other ;
   return NOT ; }

{bl}\>{bl}\>{bl} {
   return GTGT ; }

{bl}\<{bl}\<{bl} {
   return LTLT ; }

{bl}{not}{bl}\>{bl}\>{bl} {
   return NOTGTGT ; }

{bl}{not}{bl}\<{bl}\<{bl} {
   return NOTLTLT ; }

{bl}\>{bl}\>{bl}={bl} {
   return GTGTE ; }

{bl}\<{bl}\<{bl}={bl} {
   return LTLTE ; }

{bl}(\>|{not}{bl}(\<{bl}=|={bl}\<)){bl} {
   return GT ; }

{bl}({not}{bl}\<|={bl}\>|\>{bl}=){bl} {
   return GTE ; }

{bl}(\<|{not}{bl}(\>{bl}=|={bl}\>)){bl} {
   return LT ; }

{bl}({not}{bl}\>|={bl}\<|\<{bl}=){bl} {
   return LTE ; }

{bl}({not}{bl}=|\<{bl}\>|\>{bl}\<){bl} {
   return DIFFERENT ; }

{bl}={bl}={bl} {
   return EQUALEQUAL ; }

{bl}{not}{bl}={bl}={bl} {
   return NOTEQUALEQUAL ; }

{bl}\/{bl}\/{bl} {
   return MODULUS ; }

{bl}&{bl}&{bl} {
   return XOR ; }

{bl}\|{bl}\|{bl} {
   return CONCATENATE ; }

{bl}\*{bl}\*{bl} {
   return EXP ; }

{bl}[ \t]{bl} {
   if (kill_this_space)
   {
      return yylex() ;
   }
   if (in_address)
   {
      in_address = 0 ;
      return yylex() ;
   }
   return (((in_parse)&&(!seek_with)) ? yylex() : SPACE) ; }

['"] {
   exiterror( ERR_UNMATCHED_QUOTE, 0 )  ; }


[^A-Za-z0-9 \t\n@#$&|.?!_*()+=%\\^'";:<,>/-] {
   exiterror( ERR_INVALID_CHAR, 1, isprint(yytext[0])?yytext[0]:0, yytext[0] ) ;}

: {
   exiterror( ERR_SYMBOL_EXPECTED, 0 ) ;}

. {
   exiterror( ERR_INTERPRETER_FAILURE, 0 )  ; }


%%

#define NORMALSTAT  0
#define COMMENTSTAT 1
#define SINGLEQUOTE 2
#define DOUBLEQUOTE 3

static int inEOF=0 ;
static int linenr=1 ;
static int singlequote=0, doblequote=0 ;
static int firstln=0 ;
static int bufptr=0 ;
/* Previous bug. 8-bits clean combined with EOF ==> need at least short */
static short chbuffer[LOOKAHEAD] ;
static int ipretflag=0, cch=0 ;
static char *interptr=NULL ;
static char *interptrmax ;
static int cchmax = 0 ;

/* rmspc uppercases all characters and removes blanks from a string.
 * Returns the input string.
 */
static YY_CHAR_TYPE *rmspc( YY_CHAR_TYPE *instr )
{
   YY_CHAR_TYPE *retval=instr ,
                *dest  =instr ,
                c ;

   while ((c = *instr++) != '\0')
   {
      c = (YY_CHAR_TYPE) toupper(c);
      /* These characters are treated as blanks: */
      if ((c!=' ') && (c!=',') && (c!='\t') && (c!='\n'))
         *dest++ = c ;
   }
   *dest = '\0' ;

   return( retval ) ;
}


static void init_it_all( void )
{
   inEOF = 0 ;
   in_numform = 0 ;
   next_numform = 0 ;
   next = last = prev = 0 ;
   obs_with = 0 ;
   in_do = 0 ;
   in_then = 0 ;
   dontlast = 0 ;
   sum = 0 ;
   thischar = 0 ;
   firstln = 0 ;
   nnextstart = 0 ;
   in_parse = 0 ;
   in_trace = 0 ;
   itflag = 0 ;
   in_signal = 0 ;
   in_call = 0 ;
   in_address = 0 ;
   seek_with = 0 ;
   kill_this_space = 0 ;
   kill_next_space = 1 ;
   ipretflag = 0 ;
   do_level = 0 ;
   singlequote = doblequote = 0 ;
   cch = bufptr = 0 ;
}


void initexternal( FILE *fptr )
{
#ifndef FLEX_SCANNER
#ifdef HPUX
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#else
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#endif
#endif

   first_source_line = last_source_line = NULL ;
#ifdef NEW_LEX_STYLE
   linenr = nextline = 0 ;
   nextstart = 1;
#else
   linenr = nextstart = nextline = 1 ;
#endif
   init_it_all() ;

   /* BUG. Fix this, or be hanged. Will not handle recursive
      interpretations. */
   bufptr=0;
#ifdef FLEX_SCANNER
   yy_init = 1 ;
   yy_delete_buffer(YY_CURRENT_BUFFER) ;
   yyrestart(fptr) ;
#else
   yysptr = yysbuf ;
   yyin = fptr ;
#endif
   BEGIN comm ;
}


void initinterpret( streng *str )
{
#ifndef FLEX_SCANNER
#ifdef HPUX
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#else
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#endif
#endif

   first_source_line = last_source_line = NULL ;
   cch = bufptr = 0 ;
   init_it_all() ;
   ipretflag = 1 ;
   /* BUG. Fix this, or be hanged. Will not handle recursive
      interpretations. */
   bufptr=0;
   singlequote = doblequote = 0 ;

#ifdef FLEX_SCANNER
   yy_init = 1 ;
   yy_delete_buffer(YY_CURRENT_BUFFER) ;
   yyrestart(NULL) ;
#else
   yysptr = yysbuf ;
#endif
   BEGIN comm ;
   cchmax = str->len ;
   interptr = str->value ;
   interptrmax = interptr + cchmax ;
}


void initmacro( streng *str )
{
#ifndef FLEX_SCANNER
#ifdef HPUX
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#else
   extern YY_CHAR_TYPE *yysptr, yysbuf[] ;
#endif
#endif

   first_source_line = last_source_line = NULL ;
#ifdef NEW_LEX_STYLE
   linenr = nextline = 0 ;
   nextstart = 1 ;
#else
   linenr = nextstart = nextline = 1 ;
#endif
   thischar = 0 ;

   singlequote = doblequote = 0 ;
   firstln = 0 ;
   init_it_all() ;
   do_level = 0 ;
   in_parse = 0 ;
   cch = bufptr = 0 ;
   ipretflag = 1 ;

   /* BUG. Fix this, or be hanged. Will not handle recursive
      interpretations. */
   bufptr=0;
#ifdef FLEX_SCANNER
   yy_init = 1 ;
   yy_delete_buffer(YY_CURRENT_BUFFER) ;
   yyrestart(NULL) ;
#else
   yysptr = yysbuf ;
#endif
   BEGIN comm ;
   interptrmax = str->value + str->len ;
   cchmax = str->len ;
   interptr = str->value ;
}


void initvalue( streng *str )
{
   extern int yy_start ;

   init_it_all() ;
   in_parse = 0 ;
   do_level = 0 ;
   singlequote = doblequote = 0 ;
   initinterpret( str ) ;
   BEGIN other ;
#ifdef FLEX_SCANNER
   yy_init = 1 ;
   yy_delete_buffer(YY_CURRENT_BUFFER) ;
   yyrestart(NULL) ;
#endif
}

#ifdef NEW_LEX_STYLE
/* get_next_line: Lower level input fetcher.
 * Reads exactly one line from the input stream (file or string).
 * All EOL characters are removed and the result is stored in
 * last_source_line. A check for line overflow occurred here.
 * A special check is done for CP/M ^Z (DOS and friends use this for
 * "backward" compatibility, too).
 * line is filled with valid values on success.
 * max must reflect size of line and should be at least BUFFERSIZE + 2;
 * Returns -1 (no input) or the number of valid chars in line.
 */
static int get_next_line( char *line, int max, FILE *stream )
{
   lineboxptr newline ;
   int pos = 0;
   int c = 0, nextEOL ;

   if (inEOF) /* You can't use myunputc if EOF is reached! */
      return EOF ;

   while (pos <= max - 2)
   {
      /* get next char */
      if (bufptr>0)
         c = chbuffer[--bufptr] ;
      else if (ipretflag)
      {
         if (interptr>=interptrmax)
            c = EOF ;
         else
            c = *interptr++ ;
      }
      else
         c = getc(stream) ;

      if ((c=='\r') || (c=='\n') || (c==EOF))
         break ;
      line[pos++] = (char) (unsigned char) c ;
   }

   /* first, check for overflow */
   if ((c!='\r') && (c!='\n') && (c!=EOF))
   {
      linenr++;
      nextline++;
      exiterror( ERR_TOO_LONG_LINE, 0 )  ;
   }

   /* We have either a (first) line terminator or EOF */
   if (c==EOF)
   {
      if ((pos==1) && (line[0]=='\x1A')) /* CP/M ^Z EOF? */
         pos-- ;
      if (pos == 0)
      {
         inEOF = 1 ;
         return EOF ;
      }
      nextEOL = EOF;
   }
   else
   {
      /* get one more char */
      if (bufptr>0)
         nextEOL = chbuffer[--bufptr] ;
      else if (ipretflag)
      {
         if (interptr>=interptrmax)
            nextEOL = EOF ;
         else
            nextEOL = *interptr++ ;
      }
      else
         nextEOL = getc(stream) ;
   }

   /* Decide if the next character is the last char of a EOL pair.
    * Valid pairs are CR/LF or LF/CR. Put nextEOL back if there is no pair.
    */
   if (((c!='\n') || (nextEOL!='\r')) &&
       ((c!='\r') || (nextEOL!='\n')))
      chbuffer[bufptr++] = (short) nextEOL ;

   line[pos] = '\0';
   nextline++ ; /* Don't increment before the CP/M ^Z checking !*/
   linenr++;

   newline = (lineboxptr)Malloc(sizeof(linebox)) ;
   newline->line = Str_cre( line ) ;
   newline->prev = last_source_line ;
   newline->next = NULL ;
   newline->lineno = linenr ;

   if (first_source_line==NULL)
      first_source_line = newline ;
   else
      last_source_line->next = newline ;
   last_source_line = newline ;

   line[pos++] = '\n';
   cch = 0 ; /* not needed ? */

   return pos ;
}

/* fill_buffer: Higher level input fetcher.
 * (To allow the C-file to compile, all Rexx comments in this comment
 *  are written as "{*" "*}" instead of the normal, C-like manner.)
 * Reads lines from the input stream (yyin or string) with get_next_line.
 * Only one line is returned to allow the saving of the line number.
 * This routine replaces all comments by a single '`' sign. This allows
 * the detection of a "pseudo" blank: The fragment "say x{* *}y" uses two
 * variables, not one called "xy". The parsing of comments must be done
 * here to check for the actual numbers of open and closes ("{*" and "*}").
 * While doing this we must always check for strings since "'{*'" is not part
 * of a comment.
 * Here is a problem: Is this a nested valid comment: "{* '{*' *} *}"?
 * I think so although you cannot remove the outer comment signs without an
 * error. Everything within a comment is a comment (per def.). Counting
 * opens and closes of comment signs is an ugly trick to help the user.
 * He/she must know what he/she is doing if nesting comments!
 *
 * max_size gives the maximum size of buf. This is filled up with input.
 * We never return less than one character until EOF is reached. Thus, we
 * read more than one true input line if a comment spans over more than one
 * line.
 * A line will either be terminated by a single '\n' or by a blank. The
 * later one replaces a line continuation (',' [spaces] EOL).
 */
static int fill_buffer( char *buf, int max_size )
{
   static char line[BUFFERSIZE+2] ; /* special buffer to allow max_size */
   static int pos = 0, max = 0 ;    /* being smaller than BUFFERSIZE+1  */
   static int nesting = 0;          /* nesting level of comments        */
   char *dest, c;
   int i, squote, dquote;


   if (firstln == 0)
   {
      firstln = 1;
      nesting = 0;
      pos = 0;
      max = get_next_line( line, sizeof(line), yyin ) ;
      if (max < 0) /* empty input file */
         return 0 ;
      if (line[0] == '#')
      {  /* Ignore first line beginning this way for unix compat */
         max = 0;
         return fill_buffer( buf, max_size ) ;
      }
   }
   else if (pos < max) /* Are there still characters to transmit? */
   {
      /* Buffer already checked for correctness */
      if (max_size > max - pos)
         max_size = max - pos;
      memcpy(buf, line + pos, max_size);
      pos += max_size;
      return(max_size);
   }
   else /* Need next line */
   {
      pos = 0;
      max = get_next_line( line, sizeof(line), yyin ) ;
      if (max < 0) /* empty input file */
      {
         if (nesting)
            exiterror( ERR_UNMATCHED_QUOTE, 1 ) ;
         return 0 ;
      }
   }

   /* A new line is available, check first for an ending comment */
   if (nesting) /* This may lead to more line reading */
      {
repeated_nesting:
         while (pos < max)
         {
            c = line[pos];
            if (c == '*') /* start of comment end? */
            {
               if (line[pos+1] == '/')
               {  /* pos+1 always exists, at least '\n' */
                  if (--nesting == 0)
                  {
                     pos += 2;
                     break;
                  }
                  pos++;
               }
            }
            else if (c == '/') /* start of new begin? */
            {
               if (line[pos+1] == '*')
               {
                  nesting++;
                  pos++;
               }
            }
            pos++;
         }
         if (pos >= max)
         {
            pos = 0;
            max = get_next_line( line, sizeof(line), yyin ) ;
            if (max < 0) /* empty input file */
            {
               exiterror( ERR_UNMATCHED_QUOTE, 1 ) ;
               return 0 ;
            }
            goto repeated_nesting;
         }
      }

   /* We have something to play with. Run through the input and check for
    * strings including comments.
    */
   dest = line; /* we compress comments in line */
   squote = dquote = 0;
   while (pos < max)
   {
      /* We use selective loops to reduce comparisons */
      if (nesting)
         do
         {
            c = line[pos];
            if (c == '*') /* start of comment end? */
            {
               if (line[pos+1] == '/')
               {  /* pos+1 always exists, at least '\n' */
                  if (--nesting == 0)
                  {
                     pos += 2;
                     break;
                  }
                  pos++;
               }
            }
            else if (c == '/') /* start of new begin? */
            {
               if (line[pos+1] == '*')
               {
                  nesting++;
                  pos++;
               }
            }
            pos++;
         } while (pos < max);
      else if (squote)
         {
            while ((c = line[pos]) != '\'')
            {
               *dest++ = c;
               if (++pos >= max)
                  exiterror( ERR_UNMATCHED_QUOTE, 2 ) ;
            }
            *dest++ = '\'';
            pos++;
            squote = 0;
         }
      else if (dquote)
         {
            while ((c = line[pos]) != '\"')
            {
               *dest++ = c;
               if (++pos >= max)
                  exiterror( ERR_UNMATCHED_QUOTE, 3 ) ;
            }
            *dest++ = '\"';
            pos++;
            dquote = 0;
         }
      else
         while (pos < max)
            switch (c = line[pos])
            {
               case '\'':
                  *dest++ = c ;
                  squote = 1 ;
                  pos++ ;
                  goto outer_loop;

               case '\"':
                  *dest++ = c ;
                  dquote = 1 ;
                  pos++ ;
                  goto outer_loop;

               case '/':
                  if (line[pos + 1] == '*')
                  {
                     *dest++ = '`' ;
                     pos += 2 ;
                     nesting++ ;
                     goto outer_loop;
                  }
                  else
                  {
                     *dest++ = c;
                     pos++ ;
                  }
                  break ;

               case '`':
                  exiterror( ERR_INVALID_CHAR, 1, '`', '`' ) ;
                  break;

               default:
                  *dest++ = c;
                  pos++ ;
            }
outer_loop:
      ;
   }

   max = (int) (dest - line);

   /* Now we can replace a ',' [spaces|comments] '\n' with the line
    * continuation
    */
   i = max - 1; /* on last valid char */
   while (i >= 0)
   {
      if (!isblank(line[i]) && (line[i] != '\n'))
         break;
      i--;
   }
   /* i now -1 or on last nonblank */
   if ((i >= 0) && (line[i] == ','))
   {
      max = i + 1;
      line[i] = ' ';
   }

   if (max_size > max)
      max_size = max;
   memcpy(buf, line, max_size);
   pos = max_size;
   return(max_size);
}

#else /* !NEW_LEX_STYLE */
static int mygetc( FILE *str )
/* Third stage character input fetcher.
 * Called by mmygetchar.
 * Should be replaced.
 */
{
   lineboxptr newline ;
   static char thisline[BUFFERSIZE] ;
   int nextchar ;
   static int  previous='\n' ;

   if (bufptr>0)
   {
      thischar++ ;
      return chbuffer[--bufptr] ;
   }
   else if (ipretflag)
   {
      if (interptr>=interptrmax)
      {
         myungetc(EOF,yyin) ;
         nextchar = '\n' ;
         cch++ ;
      }
      else
         thisline[cch++] = (char) (nextchar = *interptr++) ;
   }
   else
   {
      nextchar = getc(str) ;
      if (nextchar == 0x1a) /* CP/M and DOS EOF char, only allowed after
                             * an EOL (ANSI spec of REXX).
                             * This will be not done by some editors.
                             * I think, it is best to pass EOF to the lexer
                             * if this is the last character in the file and
                             * to pass it to the lexer if this is not true.
                             * This allows a normal use in strings. FGC
                             */
         nextchar = ' ';     /* Should be rewritten */
      thisline[cch++] = (char) nextchar;
      if ((previous!='\n') && (nextchar==EOF))
      {
         myungetc(EOF,yyin) ;
         nextchar = '\n' ;
      }
      previous = nextchar ;
   }

   thisline[cch] = (char) (nextchar = (nextchar) ? nextchar : EOF) ;
   thischar++ ;
   if (nextchar=='\n')
      nextline++ ;

   if (cch>=BUFFERSIZE)
       exiterror( ERR_TOO_LONG_LINE, 0 )  ;

   if ((nextchar=='\n')) {
      thischar = 0 ;
      thisline[--cch] = '\0' ;
      newline = (lineboxptr)Malloc(sizeof(linebox)) ;
      newline->line = Str_cre( thisline ) ;
      newline->prev = last_source_line ;
      newline->next = NULL ;
      newline->lineno = linenr++ ;
      cch = 0 ;
      if (first_source_line==NULL)
         first_source_line = newline ;
      else
         last_source_line->next = newline ;
      last_source_line = newline ; }

   return ( nextchar ) ;
}


void myungetc( int ch, FILE *dummy )
/* Puts back ch into the stream.
 * Called by mygetc, mygetchar and mmygetchar.
 */
{
   thischar-- ;
   chbuffer[bufptr++] = (short)ch ;
}


static int mygetchar( void )
/* First stage character input fetcher, calls mmygetchar on demand.
 * Should be replaced or fetch more than one simple char.
 */
{
   int this ;
   static int prev, haveprev=0 ;
   extern FILE *yyin ;

   if (haveprev==1)
   {
      haveprev = 0 ;
      this = prev ;
   }
   else
      this = mmygetchar() ;

   if ((this==',')&&(!singlequote)&&(!doblequote))
   {
      this = mmygetchar() ;
      while ((this==' ')||(this=='\t')||(this=='`'))
      {
         this = mmygetchar() ;
      }
      /*
       * If LF character, return single space for continuation
       * character; ','
       */
      if (this=='\n')
      {
         return (int)' ' ;
      }
      /*
       * If CR character, check if next character is LF. If it
       * is, return single space for continuation character; ','
       * If not, put the character back in the source file.
       */
      if (this=='\r')
      {
         this = mmygetchar();
         if (this=='\n')
            return (int)' ' ;
         else
         {
            myungetc(this,yyin) ;
            return (int)' ' ;
         }
      }

      prev = this ;
      haveprev = 1 ;
      return (int)',' ;
   }

   return this ;

}


static int mmygetchar( void )
/* Second stage character input fetcher, calls mygetc on demand.
 * Called by mygetchar.
 * Should be replaced.
 */
{
   int this, next, lev ;
   extern FILE *yyin ;

   this = mygetc( yyin ) ;

   if (firstln==0)
   {
      firstln = 1 ;
      if (this=='#')
      {
         for (;(this!='\n') && (this!=EOF); this=mygetc(yyin) ) ;
         this = mygetc(yyin) ;
      }
   }

   if ((this=='\n') && doblequote )
        exiterror( ERR_UNMATCHED_QUOTE, 3 )   ;

   if ((this=='\n') && singlequote)
        exiterror( ERR_UNMATCHED_QUOTE, 2 )   ;

   if ((this=='\'')&&(doblequote==0))
      singlequote = (singlequote==0) ;

   if ((this=='"')&&(singlequote==0))
      doblequote = (doblequote==0) ;

   if ((this=='`')&&(singlequote==0)&&(doblequote==0))
       exiterror( ERR_INVALID_CHAR, 0 )  ;

   if ((this=='/')&&(singlequote==0)&&(doblequote==0)) {
      if ((next = mygetc(yyin))=='*') {
         for (lev=1;lev>0;) {
            if ((next=mygetc(yyin))=='*') {
               if ((next=mygetc(yyin))=='/')
                  lev-- ;
               else
                  myungetc(next,yyin) ; }
#ifdef NESTEDCOMMENTS
            else if (next=='/') {
               if ((next=mygetc(yyin))=='*')
                  lev++ ;
               else
                  myungetc(next,yyin) ; }
#endif
            else if (next==EOF)
                exiterror( ERR_UNMATCHED_QUOTE, 1 )  ;
               }
         this = '`' ; }
      else
         myungetc(next,yyin) ; }

   return( this ) ;
}
#endif

void initscanner( void )
{
#ifdef FLEX_SCANNER
   yy_init = 1 ;
#endif
   singlequote = doblequote = 0 ;
   do_level = 0 ;
   BEGIN comm ;
}

int yywrap( void )
{
   assert( do_level>= 0 ) ;
   if (do_level>0)
       exiterror( ERR_INCOMPLETE_STRUCT, 0 )  ;
   return 1 ;
}

